// maindlg.h : interface of the CMainDlg class
//
// Written by Bjarke Viksoe (bjarke@viksoe.dk)
// Copyright (c) 2000.
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. 
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability if it causes any damage to you or your
// computer whatsoever. It's free, so don't hassle me about it.
//
// Beware of bugs.
//
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINDLG_H__CE3FE7FB_678A_11D4_8177_00C04F0F05BA__INCLUDED_)
#define AFX_MAINDLG_H__CE3FE7FB_678A_11D4_8177_00C04F0F05BA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CMainDlg : public CDialogImpl<CMainDlg>
{
public:
   enum { IDD = IDD_MAINDLG };
   enum { TIMERID_UPDATE = 111, TIMERID_FLASH=112 };

   BEGIN_MSG_MAP(CMainDlg)
      MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
      COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAppAbout)
      COMMAND_ID_HANDLER(IDOK, OnOK)
      COMMAND_ID_HANDLER(IDCANCEL, OnOK)
      MESSAGE_HANDLER(WM_TIMER, OnTimer)
      COMMAND_HANDLER(IDC_FLASHWINDOW, BN_CLICKED, OnClickedFlashwindow)
      COMMAND_HANDLER(IDC_STAYONTOP, BN_CLICKED, OnClickedStayontop)
   END_MSG_MAP()

   CStatic m_ctlText;
   CTreeViewCtrl m_ctlTree;
   CButton m_ctlStayOnTop;
   CButton m_ctlFlashWindow;
   //
   CPen m_pen;
   bool m_bFlashWindow;

   LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
   {
      // Center the dialog on the screen
      CenterWindow();

      // Set icons
      HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
      SetIcon(hIcon, TRUE);
      HICON hIconSmall = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
      SetIcon(hIconSmall, FALSE);

      // Attach control
      m_ctlText.Attach( GetDlgItem(IDC_TEXT) );
      m_ctlTree.Attach( GetDlgItem(IDC_TREE) );
      m_ctlStayOnTop.Attach( GetDlgItem(IDC_STAYONTOP) );
      m_ctlFlashWindow.Attach( GetDlgItem(IDC_FLASHWINDOW) );

      // Set control layout
      m_ctlTree.SetIndent(0); // minimum

      m_pen.CreatePen(PS_SOLID,6,RGB(0,0,0));
      m_ctlStayOnTop.SetCheck(TRUE);
      SetTimer(TIMERID_FLASH, 1000L);
      SetTimer(TIMERID_UPDATE, 500L);

      // Force focus away from current dialog
      ::SetFocus( ::GetDesktopWindow() );

      BOOL bDummy;
      OnTimer(WM_TIMER, TIMERID_UPDATE, 0, bDummy);
      OnClickedStayontop(0,0,0,bDummy);
      OnClickedFlashwindow(0,0,0,bDummy);

      return TRUE;
   }

   LRESULT OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
   {
      CSimpleDialog<IDD_ABOUTBOX, FALSE> dlg;
      dlg.DoModal();
      return 0;
   }

   LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
   {
      // Repaint desktop because we've probably screwed it up
      ::InvalidateRect(NULL,NULL,TRUE);
      // Die
      EndDialog(wID);
      return 0;
   }

   // Create window hierachy tree.
   // This is a bit tricky. It's recursive and starts by getting to the
   // top window, then from there we add each of the found windows as
   // children to the tree.
   HTREEITEM ParseTree(HWND hWnd)
   {
      if( hWnd==NULL ) return NULL;
      HTREEITEM hParent = ParseTree(::GetParent(hWnd));
      if( hParent==NULL ) hParent = TVI_ROOT;
      CString sText;
      CString sClass;
      DWORD len = ::GetWindowTextLength(hWnd);
      if( len>0 && len<256 ) {
         ::GetWindowText(hWnd,sText.GetBuffer(256),256);
         sText.ReleaseBuffer();
      }
      ::RealGetWindowClass(hWnd, sClass.GetBuffer(128), 128);
      sClass.ReleaseBuffer();
      CString s;
      s.Format(_T("\"%s\" %s"), (LPCTSTR)sText, (LPCTSTR)sClass);
      HTREEITEM hItem = m_ctlTree.InsertItem(s,hParent,TVI_FIRST);
      m_ctlTree.Expand(hParent);
      return hItem; // return new node as parent for the next child
   };

   void PaintFlash(HWND hWnd)
   {
      CWindowDC dc( ::GetDesktopWindow() );
      CRect rcThis;
      ::GetWindowRect(m_hWnd, &rcThis);
      dc.ExcludeClipRect(&rcThis);
      CRect rc;
      ::GetWindowRect(hWnd, &rc);
      HPEN oldPen = dc.SelectPen(m_pen);
      dc.SetROP2(R2_NOTXORPEN);
      dc.Rectangle(&rc);
      dc.SelectPen(oldPen);
   };

   LRESULT OnTimer(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
   {   
      GUITHREADINFO info;
      info.cbSize = sizeof(info);
      if( ::GetGUIThreadInfo(NULL, &info)==FALSE ) return 0;
      if( info.hwndActive==m_hWnd ) return 0;
      CWindow hWnd = info.hwndFocus;
      if( ::IsWindow(hWnd)==FALSE ) return 0;

      if( wParam==TIMERID_FLASH ) {
         if( m_bFlashWindow ) {
            static bool bFlip = true;
            static HWND hWndLast = NULL;
            // If window has changed, make sure to restore old flashed image
            if( hWndLast!=hWnd && hWndLast!=NULL ) {
               // Since we XOR and keep track of how many paints we've done, we
               // should restore the old window if we have done an odd (uneven) number
               // of paints.
               if( !bFlip && ::IsWindowVisible(hWndLast) ) PaintFlash(hWndLast);
               // Repaint window silently anyway
               ::InvalidateRect(hWndLast,NULL,TRUE);
               ::SetWindowPos(hWndLast, HWND_TOP, 0,0,0,0, SWP_DRAWFRAME|SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOSIZE|SWP_NOZORDER);
               // Start at known state
               bFlip = true;
            };
            // Paint flash frame for current window
            PaintFlash(hWnd);
            bFlip = !bFlip;
            hWndLast = hWnd;
         }
      }
      else if( wParam==TIMERID_UPDATE ) {

         // If window hasn't changed, then don't update display
         static HWND hWndLast = NULL;
         if( hWndLast==hWnd ) return 0;
         hWndLast = hWnd;

         CRect rcText;
         m_ctlText.GetClientRect(&rcText);

         // Get window text
         CString sText;
         int len = hWnd.GetWindowTextLength();
         if( len > 0 && len < 256 ) {
           hWnd.GetWindowText(sText.GetBuffer(256), 256);
           sText.ReleaseBuffer();
         }
         // Get class name (NT4 SP4 method)
         CString sClass;
         ::RealGetWindowClass(hWnd, sClass.GetBuffer(256), 256);
         sClass.ReleaseBuffer();
         // Get module file name:
         CString sFileName;
         /*
         HMODULE hInstance = (HMODULE)::GetWindowLong(info.hwndActive, GWL_HINSTANCE);      
         //HMODULE hInstance = (HMODULE)::GetWindowLong(::GetForegroundWindow(), GWL_HINSTANCE);
         len = ::GetWindowModuleFileName(hWnd, sFileName.GetBuffer(MAX_PATH), MAX_PATH);
         sFileName.ReleaseBuffer();
         */
         DWORD dwProcessId;
         HMODULE hProcess; 
         ::GetWindowThreadProcessId(info.hwndActive, &dwProcessId);
         hProcess = (HMODULE)::OpenProcess(PROCESS_QUERY_INFORMATION|PROCESS_VM_READ, FALSE, dwProcessId);
         len = ::GetModuleFileName(hProcess, sFileName.GetBuffer(MAX_PATH), MAX_PATH);
         sFileName.ReleaseBuffer(len);
         if( len==0 && hProcess!=0 ) {
            // Under WindowsNT we need something smarter.
            // Dynamically link to PSAPI.DLL
            typedef DWORD (CALLBACK* LPGETMODULEFILENAMEEX)(HANDLE,HMODULE,LPTSTR,DWORD);
            typedef BOOL (CALLBACK* LPENUMPROCESSMODULES)(HANDLE,HMODULE*,DWORD,LPDWORD);
#ifdef _UNICODE
            LPGETMODULEFILENAMEEX lpfnGetModuleFileNameEx = (LPGETMODULEFILENAMEEX)
               ::GetProcAddress(::LoadLibrary(_T("psapi.dll")), _T("GetModuleFileNameExW"));
#else
            LPGETMODULEFILENAMEEX lpfnGetModuleFileNameEx = (LPGETMODULEFILENAMEEX)
               ::GetProcAddress(::LoadLibrary(_T("psapi.dll")), _T("GetModuleFileNameExA"));
#endif
            LPENUMPROCESSMODULES lpfnEnumProcessModules = (LPENUMPROCESSMODULES)
               ::GetProcAddress(::LoadLibrary(_T("psapi.dll")), _T("EnumProcessModules"));
            if( lpfnGetModuleFileNameEx!=NULL && lpfnEnumProcessModules!=NULL ) {
               HMODULE hModule;
               DWORD c;
               // Get first module and ask for filename
               if( lpfnEnumProcessModules(hProcess, &hModule, 4, &c) ) {
                  len = lpfnGetModuleFileNameEx(hProcess, hModule, sFileName.GetBuffer(MAX_PATH), MAX_PATH);
                  sFileName.ReleaseBuffer(len);
               }
            }
         }

         CClientDC dc( m_ctlText );
         ::PathCompactPath( dc, const_cast<LPTSTR>((LPCTSTR)sFileName), rcText.Width() );

         // Set info text
         CString s;
         s.Format(_T("Current Window: %08X\nText: %s\nClass: %s\nModule: %s"), 
           hWnd.m_hWnd, 
           (LPCTSTR)sText, 
           (LPCTSTR)sClass, 
           (LPCTSTR)sFileName);
         m_ctlText.SetWindowText(s);

         // Create tree
         m_ctlTree.SetRedraw(FALSE);
         m_ctlTree.DeleteAllItems();
         ParseTree(hWnd);
         m_ctlTree.SetRedraw(TRUE);
      }

      return 0;
   }

   LRESULT OnClickedFlashwindow(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
   {
      m_bFlashWindow = m_ctlFlashWindow.GetCheck()==TRUE;
      ::InvalidateRect(NULL,NULL,TRUE);
      return 0;
   }

   LRESULT OnClickedStayontop(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
   {
      DWORD uFlags = SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE;
      SetWindowPos(m_ctlStayOnTop.GetCheck() ? HWND_TOPMOST : HWND_NOTOPMOST,0,0,0,0, uFlags);
      return 0;
   }
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINDLG_H__CE3FE7FB_678A_11D4_8177_00C04F0F05BA__INCLUDED_)
